﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Silverlight.Controls;
using Infragistics.Silverlight;

namespace SilverlightApplication7
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            this.TestXamWebGrid.ItemsSource = new ObservableCollection<DataItem>()
                                                  {
                                                      new DataItem() {Text = "row1", Count = 1},
                                                      new DataItem() {Text = "row2", Count = 2},
                                                      new DataItem() {Text = "row3", Count = 3},
                                                      new DataItem() {Text = "row4", Count = 4},
                                                      new DataItem() {Text = "row5", Count = 5},
                                                      new DataItem() {Text = "row6", Count = 6},
                                                      new DataItem() {Text = "row1", Count = 1},
                                                      new DataItem() {Text = "row2", Count = 2},
                                                      new DataItem() {Text = "row3", Count = 3},
                                                      new DataItem() {Text = "row4", Count = 4},
                                                      new DataItem() {Text = "row5", Count = 5},
                                                      new DataItem() {Text = "row6", Count = 6},
                                                      new DataItem() {Text = "row7", Count = 7}
                                                  };
        }

        private void DragSource_DragStart(object sender, DragDropStartEventArgs e)
        {
            CellControl sourceCell = (CellControl)VisualTreeHelper.GetParent(e.DragSource);

            if (sourceCell.Cell.Row.RowType != RowType.DataRow)
                e.Cancel = true;
        }

        private void DragSource_Drop(object sender, DropEventArgs e)
        {
            CellControl sourceCell = (CellControl)VisualTreeHelper.GetParent(e.DragSource);
            CellControl targetCell = (CellControl)VisualTreeHelper.GetParent(e.DropTarget);
            XamWebGrid grid = targetCell.Cell.Row.ColumnLayout.Grid;
            Row tmpRow;
            
            if (sourceCell == targetCell)
                return;

            if (targetCell.Cell.Row.RowType != RowType.DataRow)
                return;

            if ((sourceCell.Cell.Column.ColumnLayout == targetCell.Cell.Column.ColumnLayout))
            {
                tmpRow = (Row)sourceCell.Cell.Row;
                tmpRow.Delete();

                // NOTE: this will only work with non-hierarchical grid
                // if in child band, the corresponding RowCollection needs to be used instead
                grid.Rows.Insert(targetCell.Cell.Row.Index, tmpRow);
            }
        }
    }
}
